SKIP_SQUASH?=1
LOCALDATA=$(shell pwd)/.nxdata
IMAGE=opsperator/nexus
-include Makefile.cust

.PHONY: build
build:
	SKIP_SQUASH=$(SKIP_SQUASH) hack/build.sh

.PHONY: test
test:
	docker exec nexus /bin/sh -c 'curl http://127.0.0.1:8081/' 2>&1 \
	    | grep '<title>Nexus Repository Manager</title>'

.PHONY: tmpfsdemo
tmpfsdemo:
	@@docker rm -f nexus || true
	@@docker run -p8081:8081 \
	    --tmpfs /nexus-data:exec,size=5120M,uid=1001,gid=0 \
	    --name nexus \
	     -e DEBUG=yay \
	     -e NEXUS_JENKINS_DEPLOYER_ACCOUNT=jk-deploy \
	     -e NEXUS_JENKINS_ARTIFACTS_ACCOUNT=jk-artifacts \
	     -e NEXUS_DEPLOYER_SERVICE_PASSWORD=secret \
	     -e NEXUS_ARTIFACTS_SERVICE_PASSWORD=secret \
	     -e NEXUS_ADMIN_PASSWORD=admin4242 \
	     $(IMAGE)

.PHONY: demo
demo:
	@@if ! test -d "$(LOCALDATA)"; then \
	    mkdir -p "$(LOCALDATA)"; \
	else \
	    chown -R `id -u` "$(LOCALDATA)"; \
	fi
	@@docker rm -f nexus || true
	@@docker run -p8081:8081 \
	    -v "$(LOCALDATA):/nexus-data" \
	    --user `id -u` \
	    --name nexus \
	     -e DEBUG=yay \
	     -e NEXUS_JENKINS_DEPLOYER_ACCOUNT=jk-deploy \
	     -e NEXUS_JENKINS_ARTIFACTS_ACCOUNT=jk-artifacts \
	     -e NEXUS_DEPLOYER_SERVICE_PASSWORD=secret \
	     -e NEXUS_ARTIFACTS_SERVICE_PASSWORD=secret \
	     -e NEXUS_ADMIN_PASSWORD=admin4242 \
	     $(IMAGE)

.PHONY: run
run:
	@@docker run -p8081:8081 $(IMAGE)

.PHONY: kubebuild
kubebuild: kubecheck
	@@for f in image git task pipeline pipelinerun; \
	    do \
		kubectl apply -f deploy/kubernetes/tekton-$$f.yaml; \
	    done

.PHONY: kubecheck
kubecheck:
	@@kubectl version >/dev/null 2>&1 || exit 42

.PHONY: kubedeploy
kubedeploy: kubecheck
	@@for f in secrets service deployment ingress; \
	    do \
		kubectl apply -f deploy/kubernetes/$$f.yaml; \
	    done

.PHONY: ocbuild
ocbuild: occheck
	@@oc process -f deploy/openshift/imagestream.yaml | oc apply -f-
	@@BRANCH=`git rev-parse --abbrev-ref HEAD`; \
	if test "$$GIT_DEPLOYMENT_TOKEN"; then \
	    oc process -f deploy/openshift/build-with-secret.yaml \
		-p "GIT_DEPLOYMENT_TOKEN=$$GIT_DEPLOYMENT_TOKEN" \
		-p "NEXUS_REPOSITORY_REF=$$BRANCH" \
		| oc apply -f-; \
	else \
	    oc process -f deploy/openshift/build.yaml \
		-p "NEXUS_REPOSITORY_REF=$$BRANCH" \
		| oc apply -f-; \
	fi

.PHONY: occheck
occheck:
	@@oc whoami >/dev/null 2>&1 || exit 42

.PHONY: occlean
occlean: occheck
	@@oc process -f deploy/openshift/run-persistent.yaml | oc delete -f- || true
	@@oc process -f deploy/openshift/secret.yaml | oc delete -f- || true
